#include <bits/stdc++.h>
#define endl '\n'

//#pragma GCC optimize("O3")

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (1 << 20);

int n;
int p[MAXN], w[MAXN];
vector<pair<int, int> > adj[MAXN];

int read_int();

void read()
{
    n = read_int();
    for(int i = 1; i <= n; i++) p[i] = read_int();
    for(int i = 1; i <= n; i++) w[i] = read_int();
}

bool used[MAXN];
int par[MAXN];
vector<int> cycle;

bool vis[MAXN];
int64_t answer;
int64_t dp[MAXN];

void solve_dp(int u, int pr = -1)
{
    vis[u] = true;
    for(auto it: adj[u])
        if(!vis[it.first])
        {
            solve_dp(it.first, u);
            chkmax(answer, dp[u] + dp[it.first] + it.second);   
            chkmax(dp[u], dp[it.first] + it.second);
        }
}

pair<int64_t, int64_t> Q[2 * MAXN];
int lQ = 0, rQ = 0;

void solve()
{
    for(int i = 1; i <= n; i++)
        adj[p[i]].pb({i, w[i]});
    
    int64_t sum_all = 0;
    {
        int x = 1;
        while(!used[x])
        {
            used[x] = true;
            x = p[x];
        }

        while(!vis[x])
        {
            cycle.pb(x);
            vis[x] = true;
            sum_all += w[x];
            x = p[x];
        }
    }

    for(int v: cycle)
        solve_dp(v);

    int m = SZ(cycle);
    
    if(m > 1)
    {
        
        int64_t S = 0;
        
        for(int v: cycle)
        {
            int64_t add = dp[v] - S;
            while(lQ != rQ && Q[rQ - 1].second < add) rQ--;
            Q[rQ++] = {S, add};            
            S += w[v];
        }

        for(int v: cycle)
        {
            while(lQ != rQ)
            {
                int64_t dist = S - Q[lQ].first;
                if(dist > sum_all - dist) lQ++;
                else break;
            }

            if(lQ != rQ)
                chkmax(answer, dp[v] + S + Q[lQ].second);

            int64_t add = dp[v] - S;
            while(lQ != rQ && Q[rQ - 1].second < add) rQ--;
            Q[rQ++] = {S, add};            
            S += w[v];
        }
    }
    
    cout << answer << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    read();
    solve();
    return 0;
}

char buff[MAXN];
int posb = 0;

void next_char() { if(++posb == MAXN) fread(buff, 1, MAXN, stdin), posb = 0; }

int read_int()
{
    int ret = 0;
    for(; buff[posb] < '0' || buff[posb] > '9'; next_char());
    for(; buff[posb] >= '0' && buff[posb] <= '9'; next_char())
        ret = ret * 10 + buff[posb] - '0';
    
    return ret;
}
