#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
bool chkmax(int &x, const int &y) { return x < y ? x = y, 1 : 0; }
bool chkmin(int &x, const int &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (1 << 20);

int n, p[MAXN], c[MAXN];

void read()
{
    cin >> n;
    for(int i = 1; i <= n; i++) cin >> p[i];
    for(int i = 1; i <= n; i++) cin >> c[i];
}

vector<pair<int, int> > answer;

void SWAP(int i, int j)
{
    answer.pb({i, j});
    swap(p[i], p[j]);
    swap(c[i], c[j]);
}

bool vis[MAXN];

void fix(vector<int> li)
{
    int m1 = -1, m2 = -1;
    for(int i: li)
        if(c[p[i]] != c[i])
        {
            m1 = i;
            m2 = p[i];
            break;
        }

    int len = SZ(li);
    
    while(len > 2)
    {
        vector<int> st;
        int x = p[m2];
        while(c[p[x]] == c[x])
            st.push_back(x), x = p[x];
        st.push_back(x);

        //cout << x << " " << len << " " << m1 << " " << m2 << endl << flush;

        if(x == m1)
        {
            while(SZ(st) > 1)
            {
                int will_kill = st.back();
                SWAP(m2, will_kill);
                m2 = will_kill;
                st.pop_back();
                len--;
            }

            m1 = st.back();
            break;
        }
        else
        {
            while(!st.empty())
            {
                int will_kill = st.back();
                int qq = p[will_kill];
                SWAP(qq, will_kill);
                if(qq == m1) m1 = will_kill;
                st.pop_back();
                len--;
            }
        }
    }

    SWAP(m1, m2);
}

bool by_col(const vector<int> &i, const vector<int> &j) { return c[i[0]] < c[j[0]]; }

vector<int> qli[MAXN];

void solve()
{
    vector<vector<int> > same_col;
    for(int i = 1; i <= n; i++)
        if(!vis[i])
        {
            int x = i;
            int frst = -1;
            bool fix_it = false;

            vector<int> li;
            while(!vis[x])
            {
                vis[x] = true;
                if(frst == -1) frst = c[x];
                if(frst != c[x]) fix_it = true; 
                li.pb(x);
                x = p[x];
            }

            if(fix_it)
                fix(li);
            else if(SZ(li) > 1)
                same_col.pb(li);
        }

    for(int i = 0; i < SZ(same_col); i++)
        qli[c[same_col[i][0]]].pb(i);

    set<pair<int, int> > st;
    for(int i = 1; i <= n; i++)
        if(!qli[i].empty())
            st.insert({SZ(qli[i]), i});

    while(SZ(st) > 1)
    {
        int c1 = prev(st.end())->second, c2 = prev(prev(st.end()))->second;
        st.erase(prev(st.end()));
        st.erase(prev(st.end()));
    
        SWAP(same_col[qli[c1].back()][0],
             same_col[qli[c2].back()][0]);
    
        qli[c1].pop_back();
        qli[c2].pop_back();
        
        if(!qli[c1].empty()) st.insert({SZ(qli[c1]), c1});
        if(!qli[c2].empty()) st.insert({SZ(qli[c2]), c2});
    }

    same_col.clear();
    memset(vis, 0, sizeof(vis));
    for(int i = 1; i <= n; i++)
        if(!vis[i])
        {
            int x = i;
            int frst = -1;
            bool fix_it = false;

            vector<int> li;
            while(!vis[x])
            {
                vis[x] = true;
                if(frst == -1) frst = c[x];
                if(frst != c[x]) fix_it = true; 
                li.pb(x);
                x = p[x];
            }

            if(fix_it)
                fix(li);
            else if(SZ(li) > 1)
                same_col.pb(li);
        }
    
    if(SZ(same_col))
    {
        int need_col = c[same_col[0][0]];
        
        vector<int> perm(n, 0);
        for(int i = 0; i < n; i++) perm[i] = i + 1;
        random_shuffle(ALL(perm));

        for(int i: perm)
            if(need_col != c[i])
            {
                for(int j = 0; j < SZ(same_col); j++)
                {
                    SWAP(i, same_col[j][0]);
                    i = same_col[j][0];
                }

                break;
            }
    
        same_col.clear();
        memset(vis, 0, sizeof(vis));
        for(int i = 1; i <= n; i++)
            if(!vis[i])
            {
                int x = i;
                int frst = -1;
                bool fix_it = false;

                vector<int> li;
                while(!vis[x])
                {
                    vis[x] = true;
                    if(frst == -1) frst = c[x];
                    if(frst != c[x]) fix_it = true; 
                    li.pb(x);
                    x = p[x];
                }

                if(fix_it)
                    fix(li);
                else if(SZ(li) > 1)
                    same_col.pb(li);
            }
    }

    cout << SZ(answer) << endl;
    for(auto it: answer)
        cout << it.first << " " << it.second << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    read();
    solve();
    return 0;
}
