#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (1 << 20);

int n;
int p[MAXN], w[MAXN];
vector<pair<int, int> > adj[MAXN];

void read()
{
    cin >> n;
    for(int i = 1; i <= n; i++) cin >> p[i];
    for(int i = 1; i <= n; i++) cin >> w[i];
}

bool used[MAXN];
int par[MAXN];
vector<int> cycle;

bool vis[MAXN];

void dfs1(int u, int pr = -1)
{
    par[u] = pr;
    used[u] = true;
    vis[u] = true;
    for(auto it: adj[u])
        if(!used[it.first])
            dfs1(it.first, u);
        else if(it.first != par[u] && vis[it.first])
        {
            int tmp = u;
            cycle.pb(u); 

            while(tmp != it.first)
            {
                cin.get();
                tmp = par[tmp];
                cycle.pb(tmp); 
            }
        }

    vis[u] = false;
}

int nxt[MAXN];
int nxt_w[MAXN];

int64_t answer;
int64_t dp[MAXN];

void solve_dp(int u, int pr = -1)
{
    pair<int64_t, int64_t> two_best = {0, 0};
    for(auto it: adj[u])
        if(!used[it.first] && it.first != pr)
        {
            solve_dp(it.first, u);
            chkmax(dp[u], dp[it.first] + it.second);
            
            chkmax(two_best.second, dp[it.first] + it.second);
            if(two_best.first < two_best.second) 
                swap(two_best.first, two_best.second);
        }

    chkmax(answer, two_best.first + two_best.second);
}

void solve()
{
    for(int i = 1; i <= n; i++)
    {
        adj[p[i]].pb({i, w[i]});
        adj[i].pb({p[i], w[i]});
    }

    dfs1(1);
   
    memset(used, 0, sizeof(used));
    for(int v: cycle)
        used[v] = true;

    for(int v: cycle)
        solve_dp(v);

    int m = SZ(cycle);
    
    if(m > 1)
    {
        int64_t sum_all = 0;
        for(int j = m - 1, i = 0; i < m; i++, j = (j + 1) % m)
        {
            nxt[cycle[j]] = cycle[i]; 
            for(auto it: adj[cycle[j]])
                if(it.first == cycle[i])
                    nxt_w[cycle[j]] = it.second;

            sum_all += nxt_w[cycle[j]];
        }

        deque<pair<int64_t, int64_t> > Q;
    
        int64_t S = 0;
        for(int v: cycle)
        {
            while(!Q.empty())
            {
                int64_t dist = S - Q.front().first;
                if(dist > sum_all - dist) Q.pop_front();
                else break;
            }

            if(!Q.empty())
                chkmax(answer, dp[v] + S + Q.front().second);

            int64_t add = dp[v] - S;
            while(!Q.empty() && Q.back().second < add) Q.pop_back();
            Q.push_back({S, add});            
            S += nxt_w[v];
        }
    }
    
    cout << answer << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    read();
    solve();
    return 0;
}
