#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cassert>

using namespace std;

//#define NDEBUG

vector<vector<pair<uint32_t, uint64_t>>> ss;
vector<pair<uint64_t, uint64_t>> depth_node;

uint8_t is_tree=0;

vector<uint8_t> used_calc_depths;
vector<pair<uint32_t, uint64_t>> __children__calc_depths;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint32_t n;
    cin>>n;
    ss.resize(n);
    depth_node.resize(n, make_pair(UINT64_MAX, UINT64_MAX));
    used_calc_depths.resize(n);
    __children__calc_depths.reserve(n);
    vector<uint32_t> tmp(ss.size());
    for(uint32_t i=0; i<ss.size(); i++)
    {
        cin>>tmp[i];
        tmp[i]--;
        ss[i].reserve((ss.size()>>4)+16);
    }
    for(uint32_t i=0; i<ss.size(); i++)
    {
        uint32_t x;
        cin>>x;
        if(tmp[i]!=i)
        {
            ss[i].push_back(make_pair(tmp[i], x));
            ss[tmp[i]].push_back(make_pair(i, x));
        }
        else
        {
            is_tree++;
        }
    }
    //assert(is_tree<=1);
}

void calc_depths(uint32_t cur)
{
    bool is_leaf=1;
    used_calc_depths[cur]=1;
    for(uint32_t i=0; i<ss[cur].size(); i++)
    {
        if(used_calc_depths[ss[cur][i].first]==0)
        {
            is_leaf=0;
            calc_depths(ss[cur][i].first);
        }
    }
    if(is_leaf==1)
    {
        depth_node[cur].first=0;
    }
    else
    {
        __children__calc_depths.clear();
        for(uint32_t i=0; i<ss[cur].size(); i++)
        {
            if(used_calc_depths[ss[cur][i].first]==2)
            {
                __children__calc_depths.push_back(ss[cur][i]);
            }
        }

        for(uint32_t i=0; i<__children__calc_depths.size(); i++)
        {
            if(depth_node[cur].first==UINT64_MAX||
                depth_node[cur].first<=depth_node[__children__calc_depths[i].first].first+__children__calc_depths[i].second)
            {
                depth_node[cur].second=depth_node[cur].first;
                depth_node[cur].first=depth_node[__children__calc_depths[i].first].first+__children__calc_depths[i].second;
            }
            else if(depth_node[cur].first!=UINT64_MAX&&(
                    depth_node[cur].second==UINT64_MAX||
                    depth_node[cur].second<=depth_node[__children__calc_depths[i].first].first+__children__calc_depths[i].second))
            {
                depth_node[cur].second=depth_node[__children__calc_depths[i].first].first+__children__calc_depths[i].second;
            }
        }
    }

    used_calc_depths[cur]=2;
}

uint64_t best_inside_tree=0;

void calc_best_inside_tree()
{
    for(uint32_t i=0; i<depth_node.size(); i++)
    {
        if(depth_node[i].first!=UINT64_MAX)
        {
            best_inside_tree=max(best_inside_tree, depth_node[i].first);
            if(depth_node[i].second!=UINT64_MAX)
            {
                best_inside_tree=max(best_inside_tree, depth_node[i].first+depth_node[i].second);
            }
        }

    }
}

int main()
{
    init();
    if(is_tree)
    {
        calc_depths(0);
        calc_best_inside_tree();
        //for(uint32_t i=0; i<depth_node.size(); i++)
        //    cout<<i+1<<' '<<depth_node[i].first<<' '<<depth_node[i].second<<endl;
        cout<<best_inside_tree<<endl;
    }
    else
        abort();


    return 0;
}
