#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cassert>
#include <stack>
#include <ctime>

using namespace std;

//#define NDEBUG

vector<vector<pair<uint32_t, uint64_t>>> ss;
vector<pair<uint64_t, uint64_t>> depth_node;

uint8_t is_tree=0;

vector<uint8_t> used_calc_depths;
vector<pair<uint32_t, uint64_t>> __children__calc_depths;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint32_t n;
    cin>>n;
    ss.resize(n);
    depth_node.resize(n, make_pair(UINT64_MAX, UINT64_MAX));
    used_calc_depths.resize(n);
    __children__calc_depths.reserve(n);
    vector<uint32_t> tmp(ss.size());
    for(uint32_t i=0; i<ss.size(); i++)
    {
        cin>>tmp[i];
        tmp[i]--;
        ss[i].reserve((ss.size()>>8)+16);
    }
    for(uint32_t i=0; i<ss.size(); i++)
    {
        uint32_t x;
        cin>>x;
        if(tmp[i]!=i)
        {
            ss[i].push_back(make_pair(tmp[i], x));
            ss[tmp[i]].push_back(make_pair(i, x));
        }
        else
        {
            is_tree++;
        }
    }
    for(uint32_t i=0; i<ss.size(); i++)
        sort(ss[i].begin(), ss[i].end());
    //assert(is_tree<=1);
}

vector<bool> in_cycle_used;

void calc_depths(uint32_t cur)
{
    bool is_leaf=1;
    used_calc_depths[cur]=1;
    for(uint32_t i=0; i<ss[cur].size(); i++)
    {
        if(in_cycle_used.size()==ss.size()&&in_cycle_used[ss[cur][i].first]==true)
            continue;
        if(used_calc_depths[ss[cur][i].first]==0)
        {
            is_leaf=0;
            calc_depths(ss[cur][i].first);
        }
    }
    if(is_leaf==1)
    {
        depth_node[cur].first=0;
    }
    else
    {
        __children__calc_depths.clear();
        for(uint32_t i=0; i<ss[cur].size(); i++)
        {
            if(in_cycle_used.size()==ss.size()&&in_cycle_used[ss[cur][i].first]==true)
                continue;
            if(used_calc_depths[ss[cur][i].first]==2)
            {
                __children__calc_depths.push_back(ss[cur][i]);
            }
        }

        for(uint32_t i=0; i<__children__calc_depths.size(); i++)
        {
            if(depth_node[cur].first==UINT64_MAX||
                depth_node[cur].first<=depth_node[__children__calc_depths[i].first].first+__children__calc_depths[i].second)
            {
                depth_node[cur].second=depth_node[cur].first;
                depth_node[cur].first=depth_node[__children__calc_depths[i].first].first+__children__calc_depths[i].second;
            }
            else if(depth_node[cur].first!=UINT64_MAX&&(
                    depth_node[cur].second==UINT64_MAX||
                    depth_node[cur].second<=depth_node[__children__calc_depths[i].first].first+__children__calc_depths[i].second))
            {
                depth_node[cur].second=depth_node[__children__calc_depths[i].first].first+__children__calc_depths[i].second;
            }
        }
    }

    used_calc_depths[cur]=2;
}

uint64_t best_inside_tree=0;

void calc_best_inside_tree()
{
    for(uint32_t i=0; i<depth_node.size(); i++)
    {
        if(depth_node[i].first!=UINT64_MAX)
        {
            best_inside_tree=max(best_inside_tree, depth_node[i].first);
            if(depth_node[i].second!=UINT64_MAX)
            {
                best_inside_tree=max(best_inside_tree, depth_node[i].first+depth_node[i].second);
            }
        }
    }
}

vector<uint32_t> pred, __depth;
vector<uint32_t> cycle;
vector<uint64_t> cycle_dist_pref;
uint64_t cycle_dist_pref_other;

inline uint64_t find_dist_between (uint32_t a, uint32_t b)
{
    pair<uint32_t, uint64_t> sp=make_pair(b, 0);
    uint32_t pos=lower_bound(ss[a].begin(), ss[a].end(), sp)-ss[a].begin();
    return ss[a][pos].second;
}

void __find_cycle_find_cycle(uint32_t a, uint32_t b)
{
    /*
    cout<<a<<' '<<b<<endl;
    for(auto x:pred)
    {   cout<<x<<' ';
    }
    cout<<endl;
    */
    in_cycle_used.resize(ss.size());
    vector<uint32_t> patha, pathb;
    patha.reserve(ss.size()>>2);
    pathb.reserve(ss.size()>>2);
    while(a!=b)
    {
        //cout<<a<<' '<<b<<' '<<__depth[a]<<' '<<__depth[b]<<endl;
        if(__depth[a]>=__depth[b])
        {
            patha.push_back(a);
            a=pred[a];
        }
        else
        {
            pathb.push_back(b);
            b=pred[b];
        }
    }
    patha.push_back(a);
    /*
    for(auto x:patha)
    {   cout<<x<<' ';
    }
    cout<<endl;
    for(auto x:pathb)
    {   cout<<x<<' ';
    }
    cout<<endl;
    */
    cycle.reserve(patha.size()+pathb.size());
    for(auto x:patha)
    {   cycle.push_back(x);
        in_cycle_used[x]=true;
    }
    reverse(pathb.begin(), pathb.end());
    for(auto x:pathb)
    {   cycle.push_back(x);
        in_cycle_used[x]=true;
    }

    cycle_dist_pref.resize(cycle.size());
    cycle_dist_pref[0]=0;
    for(uint32_t i=1; i<cycle.size(); i++)
    {
        cycle_dist_pref[i]=cycle_dist_pref[i-1]+find_dist_between(cycle[i], cycle[i-1]);
    }
    cycle_dist_pref_other=find_dist_between(cycle.front(), cycle.back());
}

void find_cycle ()
{
    pred.resize(ss.size(), UINT32_MAX);
    __depth.resize(ss.size());
    stack<uint32_t> st;
    st.push(0);
    __depth[0]=0;
    pred[0]=UINT32_MAX-1;
    while(!st.empty())
    {
        uint32_t cur=st.top(); st.pop();
        for(uint32_t i=0; i<ss[cur].size(); i++)
        {
            if(pred[ss[cur][i].first]==UINT32_MAX)
            {
                st.push(ss[cur][i].first);
                pred[ss[cur][i].first]=cur;
                __depth[ss[cur][i].first]=__depth[cur]+1;
            }
            else if(pred[cur]!=ss[cur][i].first)
            {
                __find_cycle_find_cycle(cur, ss[cur][i].first);
                return;
            }
        }
    }
}

uint64_t find_shortest_distance_cycle_id(uint32_t a, uint32_t b)
{
    if(a==b)return 0;
    if(a>b)swap(a, b);
    uint64_t dist1=cycle_dist_pref[b]-cycle_dist_pref[a];
    uint64_t dist2=(cycle_dist_pref.back()-cycle_dist_pref[b])+
                   (cycle_dist_pref[a]-cycle_dist_pref.front())+
                   cycle_dist_pref_other;
    uint64_t res=min(dist1, dist2);
    res+=depth_node[cycle[a]].first+depth_node[cycle[b]].first;
    return res;
}

uint64_t res=0;

void solve_in_cycle()
{
    for(uint32_t i=0; i<cycle.size(); i++)
    {
        if(clock()>370000)
        {
            cout<<res<<'\n';
            exit(0);
        }
        for(uint64_t j=i+1; j<cycle.size(); j++)
        {
            res=max(res, find_shortest_distance_cycle_id(i, j));
        }
    }
}

int main()
{
    init();
    if(is_tree)
    {
        calc_depths(0);
        calc_best_inside_tree();
        //for(uint32_t i=0; i<depth_node.size(); i++)
        //    cout<<i+1<<' '<<depth_node[i].first<<' '<<depth_node[i].second<<endl;
        cout<<best_inside_tree<<'\n';
    }
    else
    {
        find_cycle();
        for(auto x:cycle)
            calc_depths(x);
        calc_best_inside_tree();
        res=best_inside_tree;
        /*
        for(uint32_t i=0; i<depth_node.size(); i++)
            cout<<i+1<<' '<<depth_node[i].first<<' '<<depth_node[i].second<<endl;
        for(auto x:cycle)
            cout<<x+1<<' ';
        cout<<endl;
        for(auto x:cycle_dist_pref)
            cout<<x<<' ';
        cout<<endl;
        cout<<cycle_dist_pref_other<<endl;
        cout<<in_cycle_used[3]<<endl;
        cout<<in_cycle_used[2]<<endl;
        cout<<find_shortest_distance_cycle_id(1, 2)<<endl;
        */
        solve_in_cycle();
        cout<<res<<endl;
    }


    return 0;
}
