#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 1e6 + 5;

int n;
int p[N], weight[N];

struct edge{

    int to, w;
    edge() {}
    edge(int _to, int _w) { to = _to; w = _w;}

};
vector <edge> nb[N];

int cycle[N], cycle_sz;
int in_cycle[N];

ll cycle_len;
ll ans;

bool vis[N];
int path[N], path_top;
void DFS(int v, int par = -1)
{
    vis[v] = true;
    path[path_top++] = v;
    for(auto e: nb[v])
    {
        int u = e.to;
        if(!vis[u])
            DFS(u, v);
        else
        if(u != par && cycle_sz == 0)
        {
            for(int i = path_top - 1; i >= 0; i--)
            {
                in_cycle[path[i]] = cycle_sz;
                cycle[cycle_sz++] = path[i];

                if(path[i] == u)
                    break;
            }
        }
    }
    path_top--;
}

ll depth[N], g[N];
void DFS_calc_depth(int v, int par = -1)
{
    depth[v] = 0;
    ll best[2] = {0, 0};
    for(auto e: nb[v])
    {
        int u = e.to;
        if(in_cycle[u] == -1 && u != par)
        {
            DFS_calc_depth(u, v);
            depth[v] = max(depth[v], depth[u] + e.w);

            if(depth[u] + e.w >= best[0])
            {
                best[1] = best[0];
                best[0] = depth[u] + e.w;
            }
            else
            if(depth[u] + e.w > best[1])
                best[1] = depth[u] + e.w;
        }
    }

    ans = max(ans, best[0] + best[1]);
}

int to_nxt[N];


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for(int i = 1; i <= n; i++)
        cin >> p[i];
    for(int i = 1; i <= n; i++)
        cin >> weight[i];
    for(int i = 1; i <= n; i++)
    {
        nb[i].pb(edge(p[i], weight[i]));
        nb[p[i]].pb(edge(i, weight[i]));
    }

    memset(in_cycle, -1, sizeof(in_cycle));
    DFS(1);

    for(int i = 0; i < cycle_sz; i++)
        DFS_calc_depth(cycle[i]);

//    if(cycle_sz == 1)
//    {
//        cout << ans << endl;
//        return 0;
//    }

    for(int i = 0; i < cycle_sz; i++)
    {
        int v = cycle[i];
        int nxt = cycle[(in_cycle[v] + 1) % cycle_sz];
        for(edge e: nb[v])
        {
            if(e.to == nxt)
            {
                to_nxt[v] = e.w;
                cycle_len += e.w;
                break;
            }
        }
    }

    for(int i = 0; i < cycle_sz; i++)
    {
        ll on_cycle = 0;
        for(int j = i + 1; j < cycle_sz; j++)
        {
            on_cycle += to_nxt[j - 1];
            ans = max(ans, min(cycle_len - on_cycle, on_cycle) + depth[cycle[i]] + depth[cycle[j]]);
        }
    }

    cout << ans << endl;



    return 0;
}

/*

8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8

*/
