#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 1e6 + 5;

int n;
int p[N], weight[N];

struct edge{

    int to, w;
    edge() {}
    edge(int _to, int _w) { to = _to; w = _w;}

};
vector <edge> nb[N];

vector <int> cycle;
int in_cycle[N];

bool vis[N];
vector <int> path;
void DFS(int v, int par = -1)
{
    vis[v] = true;
    path.pb(v);
    for(auto e: nb[v])
    {
        int u = e.to;
        if(!vis[u])
            DFS(u, v);
        else
        if(u != par && cycle.empty())
        {
            for(int i = (int)path.size() - 1; i >= 0; i--)
            {
                in_cycle[path[i]] = (int)cycle.size();
                cycle.pb(path[i]);

                if(path[i] == u)
                    break;
            }
        }
    }
    path.pop_back();
}

ll depth[N];
void DFS_calc_depth(int v, int par = -1)
{
    depth[v] = 0;
    for(auto e: nb[v])
    {
        int u = e.to;
        if(in_cycle[u] == -1 && u != par)
        {
            DFS_calc_depth(u, v);
            depth[v] = max(depth[v], depth[u] + e.w);
        }
    }
}

ll cycle_len;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);


    cin >> n;
    for(int i = 1; i <= n; i++)
        cin >> p[i];
    for(int i = 1; i <= n; i++)
        cin >> weight[i];
    for(int i = 1; i <= n; i++)
    {
        nb[i].pb(edge(p[i], weight[i]));
        nb[p[i]].pb(edge(i, weight[i]));
    }

    memset(in_cycle, -1, sizeof(in_cycle));
    DFS(1);

    for(auto v: cycle)
        DFS_calc_depth(v);

    if((int)cycle.size() == 1)
    {
        cout << depth[cycle[0]] << endl;
        return 0;
    }

    for(int i = 1; i <= n; i++)
        if(in_cycle[i] != -1 && in_cycle[p[i]] != -1)
            cycle_len += weight[i];


    return 0;
}

/*

8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8

*/
