#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <set>
#include <ctime>
#include <random>
#include <deque>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 1e6 + 5;
const double TL = 0.35;

bool TimeOK()
{
    return clock() < TL * (double)CLOCKS_PER_SEC;
}


int n;
int p[N], weight[N];

struct edge{

    int to, w;
    edge() {}
    edge(int _to, int _w) { to = _to; w = _w;}

};
vector <edge> nb[N];

int cycle[N], cycle_sz;
int in_cycle[N];

ll cycle_len;
ll ans;

bool vis[N];
int path[N], path_top;
void DFS(int v, int par = -1)
{
    vis[v] = true;
    path[path_top++] = v;
    for(auto e: nb[v])
    {
        int u = e.to;
        if(!vis[u])
            DFS(u, v);
        else
        if(u != par && cycle_sz == 0)
        {
            for(int i = path_top - 1; i >= 0; i--)
            {
                in_cycle[path[i]] = cycle_sz;
                cycle[cycle_sz++] = path[i];

                if(path[i] == u)
                    break;
            }
        }
    }
    path_top--;
}

ll depth[N], g[N];
void DFS_calc_depth(int v, int par = -1)
{
    depth[v] = 0;
    ll best[2] = {0, 0};
    for(auto e: nb[v])
    {
        int u = e.to;
        if(in_cycle[u] == -1 && u != par)
        {
            DFS_calc_depth(u, v);
            depth[v] = max(depth[v], depth[u] + e.w);

            if(depth[u] + e.w >= best[0])
            {
                best[1] = best[0];
                best[0] = depth[u] + e.w;
            }
            else
            if(depth[u] + e.w > best[1])
                best[1] = depth[u] + e.w;
        }
    }

    ans = max(ans, best[0] + best[1]);
}

int to_nxt[N];
ll pref_nxt[N];

ll dist(int i, int j)
{
    if(i == j)
        return 0;
    if(i > j)
        swap(i, j);

    ll d;
    if(i)
       d = pref_nxt[j - 1] - pref_nxt[i - 1];
    else
       d = pref_nxt[j - 1];
    return min(d, cycle_len - d);
}

ll dist_forward(int i, int j)
{
    if(i == j)
        return 0;
    if(i > j)
        swap(i, j);

    ll d;
    if(i)
       d = pref_nxt[j - 1] - pref_nxt[i - 1];
    else
       d = pref_nxt[j - 1];
    return d;
}


int fix(int id)
{
    return (id + cycle_sz) % cycle_sz;
}

set <pair <ll, int> > s;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for(int i = 1; i <= n; i++)
        cin >> p[i];
    for(int i = 1; i <= n; i++)
        cin >> weight[i];
    for(int i = 1; i <= n; i++)
    {
        nb[i].pb(edge(p[i], weight[i]));
        nb[p[i]].pb(edge(i, weight[i]));
    }

    memset(in_cycle, -1, sizeof(in_cycle));
    DFS(1);

    for(int i = 0; i < cycle_sz; i++)
        DFS_calc_depth(cycle[i]);

    if(cycle_sz == 1)
    {
        cout << ans << endl;
        return 0;
    }

    for(int i = 0; i < cycle_sz; i++)
    {
        int v = cycle[i];
        int nxt = cycle[(in_cycle[v] + 1) % cycle_sz];
        for(edge e: nb[v])
        {
            if(e.to == nxt)
            {
                to_nxt[i] = e.w;
                cycle_len += e.w;
                break;
            }
        }
    }

    pref_nxt[0] = to_nxt[0];
    for(int i = 1; i < cycle_sz; i++)
        pref_nxt[i] = pref_nxt[i - 1] + to_nxt[i];

    int head, tail;
    ll added;

    s.insert({depth[cycle[0]], 0});
    head = 0, tail = 0;
    added = 0;
    while(head <= tail)
    {
        while(tail < cycle_sz - 1 && dist_forward(head, tail + 1) <= cycle_len / 2)
        {
            s.insert({depth[cycle[tail + 1]] + dist_forward(0, tail + 1), tail + 1});
            tail++;
        }

        while(!s.empty())
        {
            pair <ll, int> temp = *s.rbegin();
            if(temp.second <= head)
            {
                s.erase(temp);
                continue;
            }

            ans = max(ans, depth[cycle[head]] - added + temp.first);
            break;
        }

        added += to_nxt[head];
        head++;
    }

    s.clear();

    s.insert({depth[cycle[cycle_sz - 1]], cycle_sz - 1});
    head = cycle_sz - 1, tail = cycle_sz - 1;
    added = 0;
    while(head >= tail)
    {
        while(tail > 0 && dist_forward(tail - 1, head) <= cycle_len / 2)
        {
            s.insert({depth[cycle[tail - 1]] + dist_forward(tail - 1, cycle_sz - 1), tail - 1});
            tail--;
        }

        while(!s.empty())
        {
            pair <ll, int> temp = *s.rbegin();
            if(temp.second >= head)
            {
                s.erase(temp);
                continue;
            }

            ans = max(ans, depth[cycle[head]] - added + temp.first);
            break;
        }

        if(head)
            added += to_nxt[head - 1];
        head--;
    }


    cout << ans << endl;

    return 0;
}

/*

8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8

*/
