#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <queue>
#include <climits>
#include <cmath>

#define endl '\n'

using namespace std;

const int N = (int)(1e3) + 3;

int n, p, w;
long long res;
int dir[N];

vector< pair<int, int> > v[N];
priority_queue< pair<long long, int> > q;
bool used[N];
long long dist[N];

void dijkstra(int u) {
    for(int i = 1; i <= n; ++i) {
        used[i] = 0;
        dist[i] = LLONG_MAX;
    }
    dist[u] = 0;
    q.push(make_pair(0, u));
    while(!q.empty()) {
        auto Top = q.top();
        long long currdist = -Top.first;
        int curr = Top.second;
        q.pop();
        used[curr] = 1;
        if(currdist > dist[curr]) {
            continue;
        }
        for(auto i : v[curr]) {
            if(!used[i.first] && dist[i.first] > dist[curr] + i.second) {
                dist[i.first] = dist[curr] + i.second;
                q.push(make_pair(-dist[i.first], i.first));
            }
        }
    }
    for(int i = 1; i <= n; ++i) {
        if(dist[i] != LLONG_MAX) {
            res = max(res, dist[i]);
            //cout << "dist from " << u << " to " << i << " = " << dist[i] << endl;
        }
    }
}

int main() {
    //freopen("11.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;

    for(int i = 1; i <= n; ++i) {
        cin >> p;
        dir[i] = p;
    }

    for(int i = 1; i <= n; ++i) {
        cin >> w;
        res = max(res, (long long)(w));
        if(dir[i] != i) {
            v[i].push_back(make_pair(dir[i], w));
            v[dir[i]].push_back(make_pair(i, w));
        } else return 1;
    }

    for(int i = 1; i <= n; ++i) {
        dijkstra(i);
    }

    cout << res << endl;

    return 0;
}

