#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstring>
#include <cmath>
#include <set>

#pragma GCC optimize("Ofast")

#define endl '\n'

using namespace std;

const int N = (int)(1e5) + 3;

int n;
int p[N];
int positionOf[N], colorOf[N];
set<int> s;
bool done[1003];

int main() {
    //freopen("22.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for(int i = 1; i <= n; ++i) {
        cin >> p[i];
        positionOf[p[i]] = i;
    }
    for(int i = 1; i <= n; ++i) {
        int x;
        cin >> x;
        s.insert(x);
        colorOf[p[i]] = x;
    }

    if((int)s.size() == n) {
        vector< pair<int, int> > op;
        for(int i = 1; i <= n; ++i) {
            if(positionOf[i] != i) {
                int pos1 = positionOf[i];
                int pos2 = positionOf[p[i]];
                int numb = p[i];
                op.push_back(make_pair(pos1, i));
                positionOf[i] = i;
                positionOf[p[i]] = pos1;
                p[i] = i;
                p[pos1] = numb;
            }
        }
        cout << (int)op.size() << endl;
        for(auto i : op) {
            cout << i.first << ' ' << i.second << endl;
        }
    } else {
        vector< pair<int, int> > op;
        int correct;
        while(1) {
            memset(done, 0, sizeof(done));
            //if(it >= 20) break;
            correct = 0;
            for(int i = 1; i <= n; ++i) {
                if(positionOf[i] != i) {
                    int pos1 = positionOf[i];
                    int pos2 = positionOf[p[i]];
                    int numb = p[i];
                    if(colorOf[i] != colorOf[numb]) {
                        op.push_back(make_pair(pos1, i));
                        positionOf[i] = i;
                        done[i] = 1;
                        positionOf[p[i]] = pos1;
                        p[i] = i;
                        p[pos1] = numb;
                    } else {
                        for(int j = 1; j < i; ++j) {
                            if(done[j] && colorOf[j] != colorOf[i]) {
                                //i, pos1, c[pos1] - 1
                                //numb, i, c[i] - 2
                                //j, positionOf[j], c[positionOf[j]] - 3
                                int a = pos1, b = i, x = positionOf[j];
                                op.push_back(make_pair(a, x));
                                op.push_back(make_pair(b, x));
                                op.push_back(make_pair(a, x));
                                //i, pos1, c[i] - 1
                                //numb, i, c[pos1] - 2
                                //j, positionOf[j], c[positionOf[j]] - 3
                                positionOf[i] = i;
                                positionOf[numb] = pos1;
                                done[i] = 1;
                                p[pos1] = numb;
                                p[i] = i;
                                break;
                            }
                        }
                    }
                } else done[i] = 1;
            }
            for(int i = 1; i <= n; ++i) if(positionOf[i] == i) correct++;
            if(correct == n) break;
        }
        cout << (int)op.size() << endl;
        for(auto i : op) {
            cout << i.first << ' ' << i.second << endl;
        }
    }

    return 0;
}
