#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstring>
#include <cmath>
#include <set>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")

#define endl '\n'

using namespace std;

const int N = (int)(1e5) + 3;

int n;
int p[N];
int positionOf[N], colorOf[N];
int good[1010], idx;

int main() {
    //freopen("21.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for(int i = 1; i <= n; ++i) {
        cin >> p[i];
        positionOf[p[i]] = i;
    }
    int prev = -1;
    bool task3 = true;
    for(int i = 1; i <= n; ++i) {
        int x;
        cin >> x;
        if(prev == -1) prev = x;
        else if(x != prev) task3 = false;
        prev = x;
        colorOf[p[i]] = x;
    }

    if(task3) {
        vector< pair<int, int> > op;
        for(int i = 1; i <= n; ++i) {
            if(positionOf[i] != i) {
                int pos1 = positionOf[i];
                int pos2 = positionOf[p[i]];
                int numb = p[i];
                op.push_back(make_pair(pos1, i));
                positionOf[i] = i;
                positionOf[p[i]] = pos1;
                p[i] = i;
                p[pos1] = numb;
            }
        }
        cout << (int)op.size() << endl;
        for(auto i : op) {
            cout << i.first << ' ' << i.second << endl;
        }
    } else {
        if(n > 100) {
            cout << 3 * n + 3 << endl;
            return 0;
        }
        vector< pair<int, int> > op;
        while(1) {
            idx = 0;
            for(int i = 1; i <= n; ++i) if(positionOf[i] == i) good[idx++] = i;
            if(idx == n) break;

            for(int i = 1; i <= n; ++i) {
                if(positionOf[i] != i) {
                    int pos1 = positionOf[i];
                    int numb = p[i];
                    if(colorOf[i] != colorOf[numb]) {
                        op.push_back(make_pair(pos1, i));
                        positionOf[i] = i;
                        positionOf[numb] = pos1;
                        good[idx++] = i;
                        p[i] = i;
                        p[pos1] = numb;
                    } else {
                        for(int J = idx - 1; J >= 0; --J) {
                            int j = good[J];
                            if(colorOf[j] != colorOf[i]) {
                                //i, pos1, 1
                                //numb, i, 1
                                //j, positionOf[j], 2
                                int a = pos1, b = i, x = positionOf[j];
                                op.push_back(make_pair(a, x));
                                op.push_back(make_pair(a, b));
                                op.push_back(make_pair(b, x));
                                //i, pos1, c[i] - 1
                                //numb, i, c[pos1] - 2
                                //j, positionOf[j], c[positionOf[j]] - 3
                                positionOf[i] = i;
                                good[idx++] = i;
                                positionOf[numb] = pos1;
                                p[pos1] = numb;
                                p[i] = i;
                                break;
                            }
                        }
                    }
                }
            }
        }
        cout << (int)op.size() << endl;
        for(auto i : op) {
            cout << i.first << ' ' << i.second << endl;
        }
    }

    return 0;
}
