#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <queue>
#include <climits>
#include <cmath>

#pragma GCC optimize("Ofast")

#define endl '\n'

using namespace std;

const int N = (int)(1e5) + 3;

int n, p, w;
long long res;
int dir[(int)(1e5) + 3];
bool isTask1 = 0;

vector< pair<int, int> > v[N];
priority_queue< pair<long long, int> > q;
bool used[N];
long long dist[N];

void dijkstra(int u) {
    for(int i = 1; i <= n; ++i) {
        used[i] = 0;
        dist[i] = LLONG_MAX;
    }
    dist[u] = 0;
    q.push(make_pair(0, u));
    while(!q.empty()) {
        auto Top = q.top();
        long long currdist = -Top.first;
        int curr = Top.second;
        q.pop();
        used[curr] = 1;
        if(currdist > dist[curr]) {
            continue;
        }
        for(auto i : v[curr]) {
            if(!used[i.first] && dist[i.first] > dist[curr] + i.second) {
                dist[i.first] = dist[curr] + i.second;
                q.push(make_pair(-dist[i.first], i.first));
            }
        }
    }
    for(int i = 1; i <= n; ++i) {
        if(dist[i] != LLONG_MAX) {
            res = max(res, dist[i]);
            //cout << "dist from " << u << " to " << i << " = " << dist[i] << endl;
        }
    }
}

long long res12;
int res11;
int W[(int)(1e5) + 1];

vector< pair<int, int> > v11[(int)(1e5) + 1];
vector< pair<int, long long> > v12[N];

long long dfs12(int u, int p) {
    if((int)v12[u].size() == 1 && v12[u][0].first == p) {
        return 0;
    }

    vector<long long> z;

    for(auto i : v12[u]) {
        if(i.first != p) {
            z.push_back(i.second + dfs12(i.first, u));
        }
    }

    sort(z.rbegin(), z.rend());
    res12 = max(res12, z[0] + z[1]);
    return z[0];
}


int dfs11(int u, int p) {
    if((int)v11[u].size() == 1 && v11[u][0].first == p) {
        res11 = max(res11, w);
        return 0;
    }

    vector<int> z;

    for(auto i : v11[u]) {
        if(i.first != p) {
            z.push_back(i.second + dfs11(i.first, u));
        }
    }

    sort(z.rbegin(), z.rend());
    res11 = max(res11, z[0] + z[1]);
    return z[0];
}

int main() {
    //freopen("12.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;

    for(int i = 1; i <= n; ++i) {
        cin >> p;
        if(p == i) isTask1 = 1;
        dir[i] = p;
    }

    if(!isTask1) {
        for(int i = 1; i <= n; ++i) {
            cin >> w;
            res = max(res, (long long)(w));
            if(dir[i] != i) {
                v[i].push_back(make_pair(dir[i], w));
                v[dir[i]].push_back(make_pair(i, w));
            }
        }

        if(n <= (int)(1e3)) {
            for(int i = 1; i <= n; ++i) {
                dijkstra(i);
            }

            cout << res << endl;
            return 0;
        }

        vector<int> leaves;

        for(int i = 1; i <= n; ++i) {
            if((int)v[i].size() == 1) {
                leaves.push_back(i);
            }
        }

        int cnt = 0;
        for(auto i : leaves) {
            dijkstra(i);
            cnt++;
            if(cnt >= 30) break;
        }

        cout << res << endl;

    } else {
        bool fl = 0;
        if(n < 1000) fl = 1;
        for(int i = 1; i <= n; ++i) {
            cin >> w;
            if(fl) {
                if(dir[i] == i) res11 = max(res11, w);
                else {
                    v11[i].push_back(make_pair(dir[i], w));
                    v11[dir[i]].push_back(make_pair(i, w));
                }
            } else {
                res12 = max(res12, 1LL * w);
                if(dir[i] != i) {
                    v12[i].push_back(make_pair(dir[i], 1LL *w));
                    v12[dir[i]].push_back(make_pair(i, 1LL * w));
                }
            }
        }

        if(fl) dfs11(1, -1);
        else dfs12(1, -1);

        if(fl) cout << res11 << endl;
        else cout << res12 << endl;
    }

    return 0;
}

