#include <bits/stdc++.h>
#define endl '\n'
#define stack hiqwdwqhdwqui

using namespace std;

const int N = 1000007;

struct edge {
  int to, w;

  edge(){}
  edge(int a, int b):
    to(a),
    w(b)
  {}
};

struct monotonic_rmq {
  deque < long long > d;

  void clear() {
    d.clear();
  }

  void add(long long value) {
    while(!d.empty() && d.back()<value) {
      d.pop_back();
    }

    d.push_back(value);
  }

  void remove(long long value) {
    if(!d.empty() && d.front()==value) {
      d.pop_front();
    }
  }

  long long get_max() {
    return d.front();
  }
};

int n, p[N], w[N];
vector < edge > v[N];
bool is_tree, used[N];
long long dist[N];
int comp[N], comp_sz, stack[N], stack_sz, cycle[N], cycle_sz;
long long ans, d[N], s[N], total_length;
monotonic_rmq rmq;

long long get_s(int idx) {
  return idx<0 ? 0 : s[idx];
}

void tree_dfs(int node) {
  used[node] = true;
  
  for(int i=0;i<(int)(v[node].size());i++) {
    if(!used[v[node][i].to]) {
      dist[v[node][i].to] = dist[node] + v[node][i].w;
      tree_dfs(v[node][i].to);
    }
  }
}

bool find_cycle(int node, int from) {
  used[node] = true;
  stack[stack_sz++] = node;

  for(int i=0;i<(int)(v[node].size());i++) {
    if(used[v[node][i].to] && v[node][i].to!=from) {
      while((cycle[cycle_sz++] = stack[--stack_sz]) != v[node][i].to) {}
      return true;
    }
    
    if(!used[v[node][i].to]) {
      if(find_cycle(v[node][i].to, node)) {
        return true;
      }
    }
  }

  --stack_sz;

  return false;
}

void get_d(int node) {
  used[node] = true;
  d[node] = 0;

  for(int i=0;i<(int)(v[node].size());i++) {
    if(!used[v[node][i].to]) {
      get_d(v[node][i].to);
      d[node] = max(d[node], d[v[node][i].to] + v[node][i].w);
    }
  }
}

void get_diameter_record_component(int node) {
  used[node] = true;
  comp[comp_sz++] = node;

  int i;

  for(i=0;i<(int)(v[node].size());i++) {
    if(!used[v[node][i].to]) {
      dist[v[node][i].to] = dist[node] + v[node][i].w;
      get_diameter_record_component(v[node][i].to);
    }
  }
}

void get_diameter(int root) {
  int i, who = -1;
  long long max_dist = -1;

  comp_sz = 0;
  get_diameter_record_component(root);
  for(i=0;i<comp_sz;i++) {
    if(dist[comp[i]]>max_dist) {
      max_dist = dist[comp[i]];
      who = comp[i];
    }
  }

  for(i=0;i<comp_sz;i++) {
    used[comp[i]] = false;
  }

  dist[who] = 0;
  max_dist = -1;
  
  tree_dfs(who);
  for(i=0;i<comp_sz;i++) {
    max_dist = max(max_dist, dist[comp[i]]);
  }

  for(i=0;i<comp_sz;i++) {
    used[comp[i]] = false;
  }
  used[root] = true;

#ifdef Extazy
  printf("Diameter with root %d is %lld\n", root, max_dist);
#endif

  ans = max(ans, max_dist);
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, j;

  scanf("%d", &n);
  for(i=1;i<=n;i++) {
    scanf("%d", &p[i]);
    if(i==p[i]) is_tree = true;
  }
  for(i=1;i<=n;i++) {
    scanf("%d", &w[i]);
    
    if(i!=p[i]) {
      v[i].push_back(edge(p[i], w[i]));
      v[p[i]].push_back(edge(i, w[i]));
    }
  }

  if(is_tree) {
    long long max_dist = -1;
    int who = -1;

    tree_dfs(1);
    for(i=1;i<=n;i++) {
      if(dist[i]>max_dist) {
        max_dist = dist[i];
        who = i;
      }
    }

    fill(used + 1, used + 1 + n, false);
    dist[who] = 0;

    tree_dfs(who);

    max_dist = -1;
    for(i=1;i<=n;i++) {
      max_dist = max(max_dist, dist[i]);
    }

    printf("%lld\n", max_dist);

    return 0;
  }

  find_cycle(1, -1);  
  for(i=0;i<cycle_sz;i++) {
    int next = i + 1;
    if(next==cycle_sz) next = 0;

    if(p[cycle[i]]==cycle[next]) {
      s[i] = w[cycle[i]];
    }
    else {
      s[i] = w[cycle[next]];
    }

    total_length += s[i];
  }

#ifdef Extazy
  printf("Cycle size: %d\n", cycle_sz);
  printf("Cycle:");
  for(i=0;i<cycle_sz;i++) {
    printf(" %d", cycle[i]);
  }
  printf("\n");
  printf("S:");
  for(i=0;i<cycle_sz;i++) {
    printf(" %lld", s[i]);
  }
  printf("\n");
#endif

  fill(used + 1, used + 1 + n, false);
  for(i=0;i<cycle_sz;i++) {
    used[cycle[i]] = true;
  }

  for(i=0;i<cycle_sz;i++) {
    get_d(cycle[i]);
  }

#ifdef Extazy
  for(i=0;i<cycle_sz;i++) {
    printf("d [ %d ] = %lld\n", cycle[i], d[cycle[i]]);
  }
#endif

  fill(used + 1, used + 1 + n, false);
  for(i=0;i<cycle_sz;i++) {
    used[cycle[i]] = true;
  }

  for(i=0;i<cycle_sz;i++) {
    get_diameter(cycle[i]);
    if(i>0) s[i] += s[i - 1];
  }

  /*for(i=0;i<cycle_sz;i++) {
    for(j=i+1;j<cycle_sz;j++) {
      long long curr = get_s(j - 1) - get_s(i - 1);
      curr = min(curr, total_length - curr);
      curr += d[cycle[i]] + d[cycle[j]];

      ans = max(ans, curr);
    }
  }*/

  //Handle 2(s[j - 1] - s[i - 1])<=L
  for(j=0;j<cycle_sz && 2ll*(get_s(j - 1))<=total_length;j++) {
    rmq.add(d[cycle[j]] + get_s(j - 1));
  }

  for(i=0;i<cycle_sz;i++) {
    while(j<cycle_sz && 2ll*(get_s(j - 1) - get_s(i - 1))<=total_length) {
      rmq.add(d[cycle[j]] + get_s(j - 1));
      ++j;
    }

    rmq.remove(d[cycle[i]] + get_s(i - 1));

    ans = max(ans, d[cycle[i]] - get_s(i - 1) + rmq.get_max());
  }

  //Handle 2(s[j - 1] - s[i - 1])>L
  rmq.clear();
  for(j=0;j<cycle_sz;j++) {
    if(2ll*get_s(j - 1)>total_length) break;
  }

  for(i=j;i<cycle_sz;i++) {
    rmq.add(d[cycle[i]] - get_s(i - 1));
  }

  for(i=0;i + 1<cycle_sz && !rmq.d.empty();i++) {
    while(j<cycle_sz && 2ll*(get_s(j - 1) - get_s(i - 1))<=total_length) {
      rmq.remove(d[cycle[j]] - get_s(j - 1));
      ++j;
    }

    ans = max(ans, d[cycle[i]] + total_length + get_s(i - 1) + rmq.get_max());
  }

  printf("%lld\n", ans);

  return 0;
}
