#include <bits/stdc++.h>

using namespace std;

const long long N = 1e6 + 7;

vector<long long> adj[N], adj2[N];
vector<long long> pr[N];

long long par[N], pard[N];
short used[N];
vector<long long> cycle, cw;
long long d[N];
long long m;

void dfs(long long x){
    used[x] = 1;

    long long cnt_p = 0;

    for(long long i = 0; i < (long long)adj[x].size(); i++){
        long long u = adj[x][i];
        long long w = pr[x][i];

        if(used[u] == 2){
            continue;
        }
        if(u == par[x]){
            cnt_p++;

            if(cnt_p == 2){
                cycle.push_back(x);
                cycle.push_back(u);
            }

            continue;
        }

        if(used[u] == 1){
            cycle.clear();

            long long t = x;

            while(t != u){
                cycle.push_back(t);
                cw.push_back(pard[t]);
                t = par[t];
            }
            cycle.push_back(t);
            cw.push_back(w);
            continue;
        }

        pard[u] = w;
        par[u] = x;
        dfs(u);
    }

    used[x] = 2;
}

bool part[N];
long long sum = 0;

pair<long long, long long> find_diam(long long u, long long p){
    pair<long long, long long> ans = {0, 0};

    //used[u] = 1;

    for(long long i = 0; i < (long long)adj[u].size(); i++){
        long long to = adj[u][i];
        long long w = pr[u][i];

        if(to == p){
            continue;
        }
        if(to == u){
            continue;
        }
        if(part[to]){
            continue;
        }

        pair<long long, long long> t = find_diam(to, u);

        ans.first = max(ans.first, t.first);
        ans.first = max(ans.first, ans.second + t.second + w);
        ans.second = max(ans.second, t.second + w);
    }

    return ans;
}

long long n;
vector<long long> v, prefix;

long long solve(){
    long long ans = 0;

    for(int i = 0; i < m; i++){
        pair<long long, long long> t = find_diam(cycle[i], -1);

        ans = max(ans, t.first);

        v.push_back(t.second);
        //cout << v.back() << " v.back()"<< endl;
    }

    prefix.push_back(cw[0]);
    for(int i = 1; i < m; i++){
        prefix.push_back(cw[i] + prefix[i - 1]);
    }

    for(int i = 0; i < m; i++){
        for(int j = i + 1; j < m; j++){
            long long curr_d;

            if(i == 0){
                curr_d = prefix[j - 1];
            }
            else{
                curr_d = prefix[j - 1] - prefix[i - 1];
            }

            curr_d = min(curr_d, sum - curr_d);

            ans = max(ans, curr_d + v[i] + v[j]);
        }
    }

    return ans;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;

    for(long long i = 1; i <= n; i++){
        long long x;

        cin >> x;

        adj[i].push_back(x);
        adj[x].push_back(i);
    }

    for(long long i = 1; i <= n; i++){
        long long w;

        cin >> w;

        pr[i].push_back(w);
        pr[adj[i][pr[i].size() - 1]].push_back(w);
    }

    dfs(1);

    /*for(long long x: cycle){
        cout << x << " ";
    }
    cout << endl;

    for(long long w: cw){
        cout << w << " ";
    }
    cout << endl;*/

    if(cycle.empty()){
        cycle.push_back(1);
    }
    else{
        for(long long w: cw){
            sum += w;
        }
    }

    for(long long x: cycle){
        part[x] = true;
    }

    m = (long long)cycle.size();

    long long ans = solve();

    cout << ans << "\n";

    return 0;
}
/*
8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8
*/
