#include<iostream>
#include<cstdlib>
#include<cstring>
#include<vector>

using namespace std;

const int MAXN = 1e6 + 5;


bool isCycle[MAXN];
int parent[MAXN];

bool used[MAXN];
vector < pair <int, int> > graph[MAXN];

long long answer = 0;
long long maxDepth[MAXN], maxSum[MAXN];

void DFSInit(int x, int last)
{
    used[x] = true;
    //cout << x << '\n';

    for(int i = 0;i<graph[x].size();i++)
    {
        if(graph[x][i].first==x) continue;

        if(used[ graph[x][i].first ]==false)
        {
            parent[ graph[x][i].first ] = x;
            DFSInit(graph[x][i].first, x);
        }
        else if(graph[x][i].first!=last && isCycle[ graph[x][i].first ]==false)
        {
            //cout << " -- " << graph[x][i].first << '\n';

            int u = x;
            while(true)
            {
                //cout << u << '\n';
                //system("PAUSE");

                isCycle[u] = true;
                if(u==graph[x][i].first) break;

                u = parent[u];
            }
        }
    }
}

void DFSTree(int x, int last)
{
    maxSum[x] = 0;
    maxDepth[x] = 0;
    for(int i = 0;i<graph[x].size();i++)
    {
        if(graph[x][i].first==x) continue;

        if(isCycle[ graph[x][i].first ]==false && graph[x][i].first!=last)
        {
            DFSTree(graph[x][i].first, x);
        }
    }

    int index1, index2;
    long long max1 = 0, max2 = 0;

    for(int i = 0;i<graph[x].size();i++)
    {
        if(graph[x][i].first==x) continue;

        if(isCycle[ graph[x][i].first ]==false && graph[x][i].first!=last)
        {
            maxSum[x] = max(maxSum[x], maxSum[ graph[x][i].first ]);
            maxDepth[x] = max(maxDepth[x], maxDepth[ graph[x][i].first ]+graph[x][i].second);

            if(maxDepth[ graph[x][i].first ]+graph[x][i].second > max1)
            {
                index1 = i;
                max1 = maxDepth[ graph[x][i].first ]+graph[x][i].second;
            }
        }
    }
    for(int i = 0;i<graph[x].size();i++)
    {
        if(graph[x][i].first==x) continue;

        if(isCycle[ graph[x][i].first ]==false && graph[x][i].first!=last && index1!=i)
        {
            if(maxDepth[ graph[x][i].first ]+graph[x][i].second > max2)
            {
                max2 = maxDepth[ graph[x][i].first ]+graph[x][i].second;
            }
        }
    }

    maxSum[x] = max(maxSum[x], max1 + max2);
    maxSum[x] = max(maxSum[x], maxDepth[x]);

    answer = max(answer, max1+max2);
}

int p[MAXN], w[MAXN];
vector < pair <int, long long> > v;

long long cycleSum = 0;

int main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(NULL);

    int n;
    cin >> n;

    for(int i = 1;i<=n;i++)
    {
        cin >> p[i];
    }
    for(int i = 1;i<=n;i++)
    {
        cin >> w[i];
    }
    for(int i = 1;i<=n;i++)
    {
        graph[i].push_back({p[i], w[i]});
        graph[ p[i] ].push_back({i, w[i]});
    }

    DFSInit(1, -1);

    int u = -1;
    for(int i = 1;i<=n;i++)
    {
        if(isCycle[i]==true)
        {
            u = i;
            break;
        }
    }

    if(u==-1)
    {
        DFSTree(1, -1);
        cout << answer << '\n';

        return 0;
    }

    int firstNode = u;
    memset(used, false, sizeof(used));

    while(true)
    {
        used[u] = true;

        bool succes = false;
        for(int i = 0;i<graph[u].size();i++)
        {
            if(used[ graph[u][i].first ]==false && isCycle[ graph[u][i].first ]==true)
            {
                succes = true;

                cycleSum += graph[u][i].second;
                v.push_back({u, cycleSum});
                u = graph[u][i].first;

                break;
            }
        }

        if(succes==false)
        {
            for(int i = 0;i<graph[u].size();i++)
            {
                if(graph[u][i].first==firstNode)
                {
                    cycleSum += graph[u][i].second;
                    v.push_back({u, cycleSum});


                    break;
                }
            }

            break;
        }
    }

    //cout << cycleSum << '\n';
    for(int i = 0;i<v.size();i++)
    {
        //cout << v[i].first << " " << v[i].second << '\n';
    }

    for(int i = 0;i<v.size();i++)
    {
        DFSTree(v[i].first, -1);
    }

    for(int i = 0;i<v.size();i++)
    {
        for(int j = i+1;j<v.size();j++)
        {
            long long dist = v[j-1].second;
            if(i!=0) dist -= v[i].second;

            answer = max(answer, maxDepth[ v[i].first ] + maxDepth[ v[j].first ] + min(dist, cycleSum - dist ));
            //cout << v[i].first << " -> " << v[j].first << " = " << maxDepth[ v[i].first ] << " + " << maxDepth[ v[j].first ]
            //<< " + " << v[j-1].second << '\n';
        }
    }

    cout << answer << '\n';
}
/*
8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8
*/
