#include<iostream>
#include<vector>
#include<random>
#include<queue>
#include<set>
#include<algorithm>

using namespace std;

const int MAXN = 1e5 + 5;

int n;
int p[MAXN], c[MAXN];

int pos[MAXN];
vector < pair <int, int> > answer;

void doSwap(int i, int j)
{
    answer.push_back({i, j});

    pos[ p[i] ] = j;
    pos[ p[j] ] = i;

    swap(p[i], p[j]);
    swap(c[i], c[j]);
}

void specialSolve()
{
    for(int i = 1;i<=n;i++)
    {
        if(p[i]==i) continue;
        doSwap(i, pos[i]);
    }

    cout << answer.size() << '\n';
    for(int i = 0;i<answer.size();i++)
    {
        cout << answer[i].first << " " << answer[i].second << '\n';
    }

    for(int i = 1;i<=n;i++)
    {
        cout << p[i] << " ";
    }
    cout << '\n';

    exit(0);
}

struct state
{
    vector <int> p, c;
    vector < pair <int, int> > moves;

    state()
    {
        p.assign(15, 0);
        c.assign(15, 0);
    }

    bool isOk()
    {
        for(int i = 1;i<=n;i++)
        {
            if(p[i]!=i) return false;
        }

        return true;
    }

    void doSwap(int i, int j)
    {
        swap(p[i], p[j]);
        swap(c[i], c[j]);
        moves.push_back({i, j});
    }
};

queue <state> q;
set < vector <int> > used;

void BFS()
{
    state x;
    for(int i = 1;i<=n;i++)
    {
        x.p[i] = p[i];
        x.c[i] = c[i];
    }


    q.push(x);
    while(q.empty()==false)
    {
        x = q.front();
        q.pop();

        if(used.count(x.p)==true) continue;
        used.insert(x.p);

        //for(int i = 1;i<=n;i++) cout << x.p[i] << " ";
        //cout << '\n';

        if(x.isOk()==true)
        {
            cout << x.moves.size() << '\n';
            for(int i = 0;i<x.moves.size();i++)
            {
                cout << x.moves[i].first << " " << x.moves[i].second << '\n';
            }

            exit(0);
        }

        for(int i = 1;i<=n;i++)
        {
            for(int j = i+1;j<=n;j++)
            {
                if(x.c[i]!=x.c[j])
                {
                    state newState = x;
                    newState.doSwap(i, j);

                    q.push(newState);
                }
            }
        }
    }
}

bool done[MAXN];
vector <int> order;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for(int i = 1;i<=n;i++)
    {
        cin >> p[i];
        pos[ p[i] ] = i;
    }
    for(int i = 1;i<=n;i++)
    {
        cin >> c[i];
    }

    for(int i = 1;i<=n;i++)
    {
        order.push_back(i);
    }
    random_shuffle(order.begin(), order.end());

    if(n>1000)
    {
        specialSolve();
    }

    for(int ind = 0;ind<order.size();ind++)
    {
        int i = order[ind];

        if(p[i]==i)
        {
            done[i] = true;
            continue;
        }

        int index;
        for(int j = 1;j<=n;j++)
        {
            if(p[j]==i)
            {
                index = j;
                break;
            }
        }

        if(c[i]!=c[index])
        {
            doSwap(i, index);
        }
        else
        {
            int index1 = -1;
            for(int j = 1;j<=n;j++)
            {
                if(done[j]==false && c[j]!=c[i])
                {
                    index1 = j;
                    break;
                }
            }

            if(index1==-1)
            {
                for(int j = 1;j<=n;j++)
                {
                    if(c[j]!=c[i])
                    {
                        index1 = j;
                        break;
                    }
                }
            }

            doSwap(i, index1);
            doSwap(i, index);
            if(done[index1]==true) doSwap(index, index1);
        }

        done[i] = true;
    }

    cout << answer.size() << '\n';
    for(int i = 0;i<answer.size();i++)
    {
        cout << answer[i].first << " " << answer[i].second << '\n';
    }

    /*
    for(int i = 1;i<=n;i++)
    {
        cout << p[i] << " ";
    }
    cout << '\n';
    */
}
/*
7
2 5 3 7 1 6 4
3 2 2 3 3 2 3
*/
