/*
I imagine death so much it feels more like a memory.
Is this where it gets me, on my feet, sev'ral feet ahead of me?
I see it comming, do I run, or fire my gun, or let it be?
There is no beat, no melody.
Burr,  my first friend, my enemy
If I throw away my shot, is this how you will remember me?
What if this bullet is my legacy? 
*/
#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>

uint32_t n;
uint32_t l;

const uint32_t MAX_N = 50;
const uint32_t MAX_SS = 1U << (MAX_N / 2);

void print_binary(uint64_t a, uint32_t dig, std::ostream &s = std::cerr) {
	for (uint32_t i = 0;i < dig;i++) {
		s << ((a & (1ULL << i)) > 0);
	}
}

uint64_t sets[MAX_N];

void input() {
	std::cin >> n >> l;
	for (uint32_t i = 0;i < n;i++) {
		sets[i] = 0;
		for (uint32_t j = 0;j < l;j++) {
			char c;
			std::cin >> c;
			if (c == '1') {
				sets[i] |= (1u << j);
			}
		}
	}
}

struct Entry {
	uint64_t v;
	uint64_t m;
	friend bool operator< (const Entry &a, const Entry &b) {
		return a.v < b.v;
	}
};

Entry ss1[MAX_SS];
Entry ss2[MAX_SS];
uint32_t ss1Cnt, ss2Cnt;

uint32_t build_ss(uint64_t *s, uint32_t cnt, uint32_t l, Entry *ans) {
	Entry *start = ans;
	*(ans++) = {0, 0};

	//std::cerr << l << " ";
	uint64_t mask = (1ULL << l) - 1;
	//std::cerr << "mask " << mask << " ";
	print_binary(mask, l);
	//std::cerr << "\n";
	for (uint32_t i = 0;i < cnt;i++) {
		uint64_t cur = s[i] & mask;
		Entry *end = ans;
		for (Entry *j = start;j != end;j++) {
			if ((j->v & cur) == 0) {
			//	print_binary(j->v | cur, l);
			//	std::cerr << " ";
			//	print_binary(j->m | (1uLL << i), cnt);
			//	std::cerr << "\n";
				*(ans++) = {
					j->v | cur,
					j->m | (1uLL << i)
				};

			}
		}
	}
	//std::cerr << "\n";
	return ans - start;
}

void negate(Entry *s, uint32_t cnt, uint32_t l) {
	uint64_t mask = (1ULL << l) - 1;
	Entry *end = s + cnt;
	for (;s != end;s++) {
		s->v ^= mask;
	}
}
void shift_mask(Entry *s, uint32_t cnt, uint32_t shift) {
	Entry *end = s + cnt;
	for (;s != end;s++) {
		s->m <<= shift;
	}
}

void sort(Entry *ss, uint32_t cnt) {
	std::sort(ss, ss + cnt);
}

uint64_t eq_mask() {
	uint32_t j = 0;
	for (uint32_t i = 0;i < ss1Cnt;i++) {
		while ((j < ss2Cnt) && (ss2[j] < ss1[i])) {
			j++;
		}
		if (j == ss2Cnt) {
			return 0;
		}
		if (ss1[i].v == ss2[j].v) {
			return ss1[i].m | ss2[j].m;
		}
	}
	return 0;
}


uint64_t check(uint32_t l) {
	uint32_t n1 = n / 2;
	uint32_t n2 = n - n1;

	ss1Cnt = build_ss(sets, n1, l, ss1);
	ss2Cnt = build_ss(sets + n1, n2, l, ss2);
	negate(ss1, ss1Cnt, l);
	shift_mask(ss2, ss2Cnt, n1);

	sort(ss1, ss1Cnt);
	sort(ss2, ss2Cnt);

	uint32_t ans = eq_mask();
	std::cerr << "ans ";
	print_binary(ans, n);
	std::cerr << "\n";

	return ans;
}

uint64_t build_ans(uint64_t mask) {
	uint64_t light = 0;
	uint64_t broken = 0;
	for (uint32_t i = 0;i <n;i++) {
		if ((1ULL << i) & mask) {
			broken |= light & sets[i];
			light |= sets[i];
		}
	}
	return light ^ broken;
}

int main() {
	input();
	uint32_t low = 0;
	uint32_t high = l + 1;
	uint64_t mask = 0;
	while (high - low > 1) {
		uint32_t m = (high + low) / 2;
		uint64_t cur = check(m);
		if (cur) {
			low = m;
			mask = cur;
		} else {
			high = m;
		}
	}
	std::cerr << low << "\n";
	print_binary(build_ans(mask), l, std::cout);
	std::cout << "\n";

}
