/*
I imagine death so much it feels more like a memory.
Is this where it gets me, on my feet, sev'ral feet ahead of me?
I see it comming, do I run, or fire my gun, or let it be?
There is no beat, no melody.
Burr,  my first friend, my enemy
If I throw away my shot, is this how you will remember me?
What if this bullet is my legacy? 
*/
#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>

uint32_t n;
uint32_t l;

const uint32_t MAX_N = 50;
const uint32_t MAX_SS = 1U << (MAX_N / 2);

void print_binary(uint64_t a, uint32_t dig, std::ostream &s = std::cerr) {
	for (uint32_t i = 0;i < dig;i++) {
		s << ((a & (1ULL << i)) > 0);
	}
}

uint64_t sets[MAX_N];

void input() {
	std::cin >> n >> l;
	for (uint32_t i = 0;i < n;i++) {
		sets[i] = 0;
		for (uint32_t j = 0;j < l;j++) {
			char c;
			std::cin >> c;
			if (c == '1') {
				sets[i] |= (1u << j);
			}
		}
	}
}

uint64_t ss1[MAX_SS];
uint64_t ss2[MAX_SS];
uint32_t ss1Cnt, ss2Cnt;

uint32_t build_ss(uint64_t *s, uint32_t cnt, uint64_t mask, uint64_t *ans) {
	uint64_t *start = ans;
	*(ans++) = 0;

	//std::cerr << "mask " << mask << " ";
	//print_binary(mask, l);
	//std::cerr << "\n";
	for (uint32_t i = 0;i < cnt;i++) {
		uint64_t cur = s[i] & mask;
		uint64_t *end = ans;
		for (uint64_t *j = start;j != end;j++) {
			if (((*j) & cur) == 0) {
				*(ans++) = (*j) | cur;
			}
		}
	}
	return ans - start;
}

void negate(uint64_t *s, uint32_t cnt, uint64_t targM) {
	uint64_t *end = s + cnt;
	for (;s != end;s++) {
		(*s) ^= targM;
	}
}

void sort(uint64_t *ss, uint32_t cnt) {
	std::sort(ss, ss + cnt);
//	for (uint32_t i = 0;i < cnt;i++) {
//		print_binary(ss[i], l);
//		std::cerr << "\n";
//	}
//	std::cerr << "\n";
}

bool eq_mask() {
	uint32_t j = 0;
	for (uint32_t i = 0;i < ss1Cnt;i++) {
		while ((j < ss2Cnt) && (ss2[j] < ss1[i])) {
			j++;
		}
		if (j == ss2Cnt) {
			return false;
		}
		if (ss1[i] == ss2[j]) {
			return true;
		}
	}
	return false;
}


bool check(uint64_t mask) {
	uint32_t n1 = n / 2;
	uint32_t n2 = n - n1;

	ss1Cnt = build_ss(sets, n1, mask, ss1);
	ss2Cnt = build_ss(sets + n1, n2, mask, ss2);
	negate(ss1, ss1Cnt, mask);
	//shift_mask(ss2, ss2Cnt, n1);

	sort(ss1, ss1Cnt);
	sort(ss2, ss2Cnt);

	//std::cerr << "\n";
	return eq_mask();
}

int main() {
	input();
	uint64_t ans = 0;
	for (uint32_t i = 0;i < l;i++) {
		uint64_t m = ans | (1ULL << i);
		if (check(m)) {
			ans = m;
		}
		//print_binary(ans, l);
		//std::cerr << "\n";
	}
	print_binary(ans, l, std::cout);
	//std::cout << ans << "\n";

}
