#include <bits/stdc++.h>

const int32_t MAX_N = 1e6;

struct Graph {
	bool vis[MAX_N + 5];
	int32_t n;
	std::vector< std::pair< int32_t, int32_t > > v[MAX_N + 5];	
	
	void init(int32_t _n) {
		n = _n;
	}

	void add_edge(int32_t p, int32_t q, int32_t w) {
		v[p].push_back({ q, w });
		v[q].push_back({ p, w });
	}

	std::pair< int32_t, int64_t > find_furthest_tree(int32_t x) {
		vis[x] = true;
		std::pair< int32_t, int64_t > ans = { x, 0 };
	
		for(auto &p : v[x]) {
			if(!vis[p.first]) {
				auto aux = find_furthest_tree(p.first);
				aux.second += p.second;
				
				if(aux.second > ans.second) {
					ans = aux;
				}
			}
		}

		return ans;
	}

	int64_t solve_tree() {
		auto furthest1 = find_furthest_tree(1);
		memset(vis, 0, sizeof(vis));
		auto furthest2 = find_furthest_tree(furthest1.first);
		return furthest2.second;
	}
};

int32_t p[MAX_N + 5], w[MAX_N + 5];
Graph g;

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int32_t n;
	std::cin >> n;

	for(int32_t i = 1; i <= n; i++) {
		std::cin >> p[i];
	}
	for(int32_t i = 1; i <= n; i++) {
		std::cin >> w[i];
	}

	g.init(n);

	bool isTree = false;
	for(int32_t i = 1; i <= n; i++) {
		if(i == p[i]) {
			isTree = true;
		}
		else {
			g.add_edge(i, p[i], w[i]);
		}
	}

	if(isTree) {
		std::cout << g.solve_tree() << '\n';
	}
}
