#include<iostream>
#include<algorithm>
#include<vector>
#include<queue>
#include<cstring>
#define MAX 1000001
using namespace std;
struct road
{
    int x,y;
    int cost;
    bool operator<(const road &r) const
    {
        if(cost==r.cost)
            return x<r.x;
        return cost<r.cost;
    }
};
struct node
{
    int to;
    int cost;
    node(){};
    node(int t, int c)
    {
        to=t;
        cost=c;
    }
};
road r[MAX];
vector <node> v[MAX];
int depth[MAX];
int par[MAX];
int n;
int root(int s)
{
    int s1=s;
    while(s1!=par[s1])
    {
        s1=par[s1];
    }
    while(s!=par[s])
    {
        s=par[s];
        par[s]=s1;
    }
    return s1;
}


void join(int x, int y)
{
    if(depth[x]>depth[y]) par[y]=x;
    else if(depth[x]<depth[y]) par[x]=y;
    else
    {
        depth[x]++;
        par[y]=x;
    }
}


void kruskal()
{
    int components=n;
    for(int a=0; a<n; a++)
    {
        int r1=root(r[a].x);
        int r2=root(r[a].y);
        if(r1!=r2)
        {
            join(r1, r2);
            ///cout<<r[a].x<<" "<<r[a].y<<" "<<r[a].cost<<endl;
            v[r[a].x].push_back(node(r[a].y, r[a].cost));
            v[r[a].y].push_back(node(r[a].x, r[a].cost));
            components--;
        }
        if(components==1)
            break;
    }
}

int used[MAX];
priority_queue <long long> pq;

long long dfs(int b, int i, int sum)
{
    long long best=sum;
    used[i]=1;
    for(int a=0; a<v[i].size(); a++)
    {
        if(!used[v[i][a].to])
        {
            long long newSum=sum+dfs(b,v[i][a].to,v[i][a].cost);
            if(i==b) pq.push(newSum);
            best=max(best,newSum);
        }
    }
    if(i!=b)
        return best;
    else
    {

        pq.push(0);
        long long ans=pq.top();
        pq.pop();
        ans+=pq.top();
        while(!pq.empty())pq.pop();
        return ans;
    }
}
int main()
{
    int p;
    cin>>n;
    for(int a=0; a<n; a++)
    {
        cin>>p;
        r[a].x=a+1;
        r[a].y=p;
        if(r[a].x>r[a].y)
            swap(r[a].x,r[a].y);
    }
    for(int a=0; a<n; a++)
    {
        cin>>p;
        par[a+1]=a+1;
        depth[a+1]=1;
        r[a].cost=p;
    }
    sort(r,r+n);
    kruskal();
    long long ans=0;
    for(int a=1; a<=n; a++)
    {
        memset(used,0,sizeof(used));
        long long g=dfs(a,a,0);
        ///cout<<a<<" "<<g<<endl;
        ans=max(ans,g);
    }
    cout<<ans<<endl;
    return 0;
}
/**

8
2 4 4 1 1 5 5 7
1 2 3 4 5 6 7 8
*/
