#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1000003
#define INF 1000000000000000
using namespace std;
typedef long long ll;
typedef long double ld;
int n;
vector <pair <int, ll> > adj[MAXN];
pair <int, ll> nb[MAXN];
void read()
{
    cin >> n;
    for (ll i = 1; i <= n; i++)
        cin >> nb[i].first;
    for (ll i = 1; i <= n; i++)
        cin >> nb[i].second;
}
ll depth[MAXN];
ll ans = 0;
void dfs(int ver, int par)
{
    depth[ver] = 0;
    ll max1 = 0, max2 = 0;
    for (auto i: adj[ver])
        if (i.first != par)
        {
            dfs(i.first, ver);
            if (i.second + depth[i.first] > max1)
            {
                max2 = max1;
                max1 = i.second + depth[i.first];
            }
            else if (i.second + depth[i.first] > max2)
                max2 = i.second + depth[i.first];
        }
    ans = max(ans, max1 + max2);
    depth[ver] = max1;
}
int par[MAXN];
bool used[MAXN];
int first, second;
void dfs1(int ver)
{
    used[ver] = true;
    for (auto i: adj[ver])
    {
        if (!used[i.first])
        {
            par[i.first] = ver;
            dfs1(i.first);
        }
        else if (i.first != par[ver])
        {
            first = i.first;
            second = ver;
        }
    }
}
void dfs2(int ver)
{
    depth[ver] = 0;
    ll max1 = 0, max2 = 0;
    for (auto i: adj[ver])
        if (i.first != par[ver] && !used[i.first])
        {
            dfs(i.first, ver);
            if (i.second + depth[i.first] > max1)
            {
                max2 = max1;
                max1 = i.second + depth[i.first];
            }
            else if (i.second + depth[i.first] > max2)
                max2 = i.second + depth[i.first];
        }
    ans = max(ans, max1 + max2);
    depth[ver] = max1;
}
ll prefix[MAXN];
map <pair <int, int>, ll> cost;
ll tr2[MAXN << 2];
void update2(int v, int l, int r, int pos, ll val)
{
    if (l == r)
        {
            tr2[v] = val;
            return;
        }
    int mid = (l + r) >> 1;
    if (pos <= mid)
        update2(v << 1, l, mid, pos, val);
    else
        update2((v << 1) + 1, mid + 1, r, pos, val);
    tr2[v] = max(tr2[v << 1], tr2[(v << 1) + 1]);
}
ll get2(int v, int l, int r, int x, int y)
{
    if (x > y)
        return -INF;
    if (l > y || r < x)
        return -INF;
    if (l >= x && r <= y)
        return tr2[v];
    int mid = (l + r) >> 1;
    return max(get2(v << 1, l, mid, x, y), get2((v << 1) + 1, mid + 1, r, x, y));
}
ll tr3[MAXN << 2];
void update3(int v, int l, int r, int pos, ll val)
{
    if (l == r)
        {
            tr3[v] = val;
            return;
        }
    int mid = (l + r) >> 1;
    if (pos <= mid)
        update3(v << 1, l, mid, pos, val);
    else
        update3((v << 1) + 1, mid + 1, r, pos, val);
    tr3[v] = max(tr3[v << 1], tr3[(v << 1) + 1]);
}
ll get3(int v, int l, int r, int x, int y)
{
    if (x > y)
        return -INF;
    if (l > y || r < x)
        return -INF;
    if (l >= x && r <= y)
        return tr3[v];
    int mid = (l + r) >> 1;
    return max(get3(v << 1, l, mid, x, y), get3((v << 1) + 1, mid + 1, r, x, y));
}
void solve()
{
    bool is = false;
    for (ll i = 1; i <= n; i++)
    {
        if (nb[i].first == i)
            is = true;
        else
        {
            adj[i].push_back({nb[i].first, nb[i].second});
            adj[nb[i].first].push_back({i, nb[i].second});
            cost[{i, nb[i].first}] = cost[{nb[i].first, i}] = nb[i].second;
        }
    }
    if (is)
    {
        dfs(1, -1);
        cout << ans << endl;
    }
    else
    {
        dfs1(1);
        vector <int> cycle;
        int curr = first;
        while (curr != second)
        {
            cycle.push_back(curr);
            curr = par[curr];
        }
        cycle.push_back(curr);
        memset(used, false, sizeof(used));
        for (auto i: cycle)
            used[i] = true;
        for (auto i: cycle)
            dfs2(i);
        prefix[0] = 0;
        int sz = cycle.size();
        for (int i = 1; i < sz; i++)
        prefix[i] = prefix[i-1] + cost[{cycle[i], cycle[i-1]}];
        ll all = prefix[sz-1] + cost[{cycle[0], cycle[sz-1]}];
        update2(1, 0, sz-1, 0, depth[cycle[0]]);
        update3(1, 0, sz-1, 0, depth[cycle[0]]);
        for (int i = 1; i < sz; i++)
        {
            int low = 0, high = i - 1;
            while (low < high)
            {
                int mid = (low + high) >> 1;
                if (prefix[i] - prefix[mid] <= all - (prefix[i] - prefix[mid]))
                    high = mid;
                else
                    low = mid + 1;
            }
            if (prefix[i] - prefix[low] > all - (prefix[i] - prefix[low]))
                ans = max(ans, depth[cycle[i]] + prefix[i] - all + get3(1, 0, sz-1, 0, i-1));
            else
            {
                ans = max(ans, depth[cycle[i]] + prefix[i] + get2(1, 0, sz-1, low, i-1));
                ans = max(ans, depth[cycle[i]] + prefix[i] - all + get3(1, 0, sz-1, 0, low-1));
            }
            update2(1, 0, sz-1, i, depth[cycle[i]] - prefix[i]);
            update3(1, 0, sz-1, i, depth[cycle[i]] + prefix[i]);
        }
        cout << ans << endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
