#pragma GCC optimize "Ofast"
#include <iostream>
#include <array>
#include <set>

#define D(x) std::cout << __LINE__ << ": " << #x << " = " << x << std::endl;

const int MAX_L = 51;
typedef std::array<int, MAX_L> A;

int n, l;
A inp[51];

bool pcomb(const A &a, const A &b, int bit) {
	for(int i = 0;i <= bit;i ++) {
		if(a[i] + b[i] >= 2) return false;
	}
	return true;
}

A sum(const A &a, const A &b) {
	A res;
	for(int i = 0;i < MAX_L;i ++) res[i] = a[i] + b[i];
	return res;
}

void print(A a) {
	for(int i = 0;i < l;i ++) std::cout << a[i];
	std::cout << std::endl;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> l;

	for(int i = 0;i < n;i ++) {
		for(int j = 0;j < l;j ++) {
			char c;
			std::cin >> c;
			inp[i][j] = (c == '1');
		}
	}

	std::set<A> set;

	// first step
	for(int i = 0;i < n;i ++) {
		if(inp[i][0] == 1) {
			set.insert(inp[i]);
		}
	}
	//for(auto s : set) print(s);

	for(int bit = 1;bit < l;bit ++) {
		//std::cout << "==========" << std::endl;
		std::set<A> newset;
		bool any = false;
		for(int i = 0;i < n;i ++) {
			for(auto s : set) {
				if(pcomb(s, inp[i], bit)) {
					any = true;
					newset.insert(sum(s, inp[i]));
				}
			}
		}
		if(!any) {
			//std::cout << "end\n";
			break;
		}
		set = newset;
		//for(auto s : set) print(s);
	}

	std::set<A> end;
	for(auto s : set) {
		A a;
		for(int i = 0;i < l;i ++) a[i] = (s[i] == 1);
		//print(a);
		end.insert(a);
	}
	//std::cout << "==========" << std::endl;

	print(*end.rbegin());

	return 0;
}
