#pragma GCC optimize "Ofast"
#include <iostream>
#include <queue>

#define D(x) std::cout << __LINE__ << ": " << #x << " = " << x << std::endl;
typedef long long ll;

ll n = 0;

const ll MAX_N = 1e6 + 10;

struct edge {
	ll from, to, w;
} edges[MAX_N];

std::vector<std::pair<ll, ll>> graph[MAX_N];

ll dist[MAX_N];

void dij(ll start) {
	std::fill(dist, dist+n+10, (1<<30));

	std::priority_queue<std::pair<ll, ll>> next;
	next.push({0, start});
	dist[start] = 0;
	while(next.size()) {
		auto curr = next.top();
		next.pop();
		//std::cout << "here " << curr.second << '\n';
		//curr.first *= -1;
		for(auto nei : graph[curr.second]) {
			if(dist[curr.second] + nei.second < dist[nei.first]) {
				dist[nei.first] = dist[curr.second] + nei.second;
				next.push({-dist[nei.first], nei.first});
			}
		}
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n;
	for(ll i = 0;i < n;i ++) {
		edges[i].from = i + 1;
		std::cin >> edges[i].to;
	}
	for(ll i = 0;i < n;i ++) {
		std::cin >> edges[i].w;
	}
	for(ll i = 0;i < n;i ++) {
		graph[edges[i].from].push_back({edges[i].to, edges[i].w});
		graph[edges[i].to].push_back({edges[i].from, edges[i].w});
	}

	/*
	ll ans = 0;
	for(ll i = 0;i < 100;i ++) {
		ans = std::max(ans, randsol());
	}
	*/

	dij(1);
	ll max = 1;
	for(ll i = 1;i <= n;i ++) {
		if(dist[i] > dist[max]) max = i;
		//std::cout << i << ' ' << dist[i] << '\n';
	}

	dij(max);
	for(ll i = 1;i <= n;i ++) {
		if(dist[i] > dist[max]) max = i;
		//std::cout << i << ' ' << dist[i] << '\n';
	}

	std::cout << dist[max] << std::endl;
	return 0;
}
