#pragma GCC optimize "Ofast"
#include <iostream>
#include <queue>
#include <random>
#include <ctime>

#define D(x) std::cout << __LINE__ << ": " << #x << " = " << x << std::endl;
typedef long long ll;

ll n = 0;

const ll MAX_N = 1e6 + 10;

struct edge {
	ll from, to, w;
} edges[MAX_N];

std::vector<std::pair<ll, ll>> graph[MAX_N];

ll dist[MAX_N];

void dij(ll start) {
	std::fill(dist, dist+n+10, (1ll<<60));

	std::priority_queue<std::pair<ll, ll>> next;
	next.push({0, start});
	dist[start] = 0;
	while(next.size()) {
		auto curr = next.top();
		next.pop();
		//std::cout << "here " << curr.second << '\n';
		//curr.first *= -1;
		for(auto nei : graph[curr.second]) {
			if(dist[curr.second] + nei.second < dist[nei.first]) {
				dist[nei.first] = dist[curr.second] + nei.second;
				next.push({-dist[nei.first], nei.first});
			}
		}
	}
}

ll sol(int beg) {
	ll max = beg;
	ll ans = 0;

	for(int i = 0;i < 3;i ++) {
		dij(max);
		//std::cout << "ad " << max << std::endl;
		for(ll i = 1;i <= n;i ++) {
			if(dist[i] > dist[max]) max = i;
			//std::cout << i << ' ' << dist[i] << '\n';
		}
		ans = std::max(dist[max], ans);
	}

	return ans;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	bool tree = false;

	std::cin >> n;
	for(ll i = 0;i < n;i ++) {
		edges[i].from = i + 1;
		std::cin >> edges[i].to;
	}
	for(ll i = 0;i < n;i ++) {
		std::cin >> edges[i].w;
	}
	for(ll i = 0;i < n;i ++) {
		if(edges[i].to == edges[i].from) tree = true;
		graph[edges[i].from].push_back({edges[i].to, edges[i].w});
		graph[edges[i].to].push_back({edges[i].from, edges[i].w});
	}

	std::random_device rd;
	std::default_random_engine eng(rd() + 128);
	std::uniform_int_distribution<int> dist(1, n);

	ll ans = 0;
	if(tree) {
		ans = sol(1);
	} else {
		if(n < 1e3 + 10) {
			for(ll i = 0;i < n;i ++) {
				ans = std::max(ans, sol(i+1));
			}
		} else if(n <= 1e5 + 10) {
			double tl = 0.3;
			if(n < 85000) tl = 0.35;

			while(true) {
				ans = std::max(ans, sol(dist(eng)));
				clock_t time = clock();
				if(time > tl * CLOCKS_PER_SEC) break;
			}
		} else {
			ans = std::max(ans, sol(dist(eng)));
		}
	}
	std::cout << ans << std::endl;

	return 0;
}
