#include <iostream>
#include <vector>
#include <queue>

using namespace std;

struct Road
{
    int to;
    int w;

    Road() {}

    Road(int to, int w)
    {
        this->to = to;
        this->w = w;
    }
};

vector<Road> A[1000000];
int level[1000000];
int len[1000000];
vector<int> parents[1000000];

inline bool isParent(int parent, int child)
{
    for (int i = 0; i < parents[child].size(); ++i)
    {
        if (parents[child][i] == parent)
        {
            return true;
        }
    }

    return false;
}

inline int start (int n)
{
    int last = n, nodes = 0, res = 0;

    queue <int> q;
    q.push(n);

    while (!q.empty())
    {
        int curr = q.front();
        q.pop();

        //cout << curr << '\n';
        //cin >> n;

        if (level[curr] > nodes or (level[curr] == nodes and len[curr] < res))
        {
            nodes = level[curr];
            res = len[curr];
            last = curr;
        }

        for (int i = 0; i < A[curr].size(); ++i)
        {
            if (!isParent(A[curr][i].to, curr) and
                    (level[curr] + 1 > level[A[curr][i].to] or
                     (level[curr] + 1 == level[A[curr][i].to] and len[curr] + A[curr][i].w < len[A[curr][i].to])))
            {
                //cout << curr << "->" << A[curr][i].to << ' ' << level[A[curr][i].to] << ' ' << level[curr] + 1 <<
                //        ' ' << len[A[curr][i].to] << ' ' << len[curr] + A[curr][i].w << '\n';

                level[A[curr][i].to] = level[curr] + 1;
                len[A[curr][i].to] = len[curr] + A[curr][i].w;

                q.push(A[curr][i].to);
                parents[A[curr][i].to].push_back(curr);
            }
        }
    }

    return last;
}

bool used[1000000];

inline pair<int, int> solve (int a, int levelA, int lenA)
{

    used[a] = true;

    pair<int, int> res = make_pair(levelA, lenA);

    for (int i = 0; i < A[a].size(); ++i)
    {
        if (!used[A[a][i].to])
        {
            pair<int, int> curr = solve(A[a][i].to, levelA + 1, lenA + A[a][i].w);

            if (curr.first > res.first or (curr.first == res.first and curr.second < res.second))
            {
                res = curr;
            }
        }
    }

    used[a] = false;

    return res;
}

int main  ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;

    for (int i = 0; i < n; ++i)
    {
        Road curr;
        cin >> curr.to;
        --curr.to;

        A[i].push_back(curr);
    }

    for (int i = 0; i < n; ++i)
    {
        cin >> A[i][0].w;

        A[A[i][0].to].push_back(Road(i, A[i][0].w));
    }

    pair<int, int> res = make_pair(0, 0);
    for (int i = 0; i < n; ++i)
    {
        pair<int, int> curr = solve(i, 0, 0);

        if (curr.first > res.first or (curr.first == res.first and curr.second < res.second))
        {
            res = curr;
        }

        if (res.first >= n/2)
        {
            break;
        }
    }

    cout << res.second << '\n';
    return 0;
}
